﻿#Copyright disclaimer:
#    Copyright (C) 2015,  ITHierarchy Inc (www.ithierarchy.com). ALl rights reserverd.
#    This program is free software: you can redistribute it and/or modify
#        it under the terms of the GNU General Public License as published by
#        the Free Software Foundation, either version 3 of the License, or
#        (at your option) any later version.
#
#        This program is distributed in the hope that it will be useful,
#        but WITHOUT ANY WARRANTY; without even the implied warranty of
#        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#        GNU General Public License for more details.
#
#        You should have received a copy of the GNU General Public License
#        along with this program.  If not, see <http://www.gnu.org/licenses/>.

Param(
  [string]$level

)
$DateStamp=$(((get-date)).ToString("yyyyMMddTHHmmss"))
if ($level -eq "Full"){$Backup="Bacula-*"}Else{$Backup="Bacula-$level*"}

$ClusterStoragePath="C:\ClusterStorage\volume4"  #Set your Cluster Storage path Here

#look at all nodes
$clusterNodes = Get-ClusterNode;
ForEach($item in $clusterNodes)
{
   
    write-Host "Starting Host '$($item.Name)."
    $VMs=Get-VM -ComputerName $item.Name 
        foreach ($VM in $VMs){
        
        #only get those in the Cluster Storage Path
        if ($($VM.path).ToUpper() -like ("$ClusterStoragePath\*").ToUpper()) { 
            $vm.Path
            
            write-host "Starting VM $($vm.Name) @ '$($vm.Path)'"
            $CurrentSnapShots = $VM | Get-VMSnapshot 


            #Remove old Bacula-Incrental Checkpoints (Snapshots)
            foreach ($SnapShot in $CurrentSnapShots){
                if ($SnapShot.Name -like ("$Backup")){   
                    
                    write-host "Removing VM Checkpoint '$($SnapShot.Name)'"
                    $SnapShot | Remove-VMSnapshot  
                

                    $LoopCount=0
                    do {
                        Write-host "Waiting for snapshot '$($SnapShot.name)' to delete..."
                        
                        Start-Sleep -s 10 
                        $LoopCount=$LoopCount+1
                    }while ($VM.Status -eq "Merging disks" -and $LoopCount -lt 30)
                }
            }
            

            #Create New Incremental Snapshot
            write-host "Creating Checkpoint  Bacula-$Level.$DateStamp"
            $VM | Checkpoint-VM -SnapshotName Bacula-$Level.$DateStamp
        }
    }
}
